function RaidRoll_OnLoad()

-- Test function to check if the addon was loaded
RR_Test()

-- Set up the slash commands
RaidRoll_SlashSetup()

-- Set up the event handler
RaidRoll_EventSetup()

-- Set default variables
RaidRoll_DefaultSetup()


end

-- Test function to check if the addon was loaded
function RR_Test()
	ChatFrame1:AddMessage("Kilerpet's Raid Roll Addon - Loaded")
end

-- Set up the slash commands
function RaidRoll_SlashSetup()

 SLASH_RR1 = "/rr";
 SLASH_RR2 = "/raidroll";
 
 SlashCmdList["RR"] =  RR_Command;

end

-- Set up the event handler
function RaidRoll_EventSetup()

 local f = CreateFrame("Frame")
 
  f:RegisterEvent("CHAT_MSG_SYSTEM")
  
  f:RegisterEvent("CHAT_MSG_PARTY")
  f:RegisterEvent("CHAT_MSG_RAID")
  f:RegisterEvent("CHAT_MSG_RAID_LEADER")
  f:RegisterEvent("CHAT_MSG_RAID_WARNING")
  f:RegisterEvent("CHAT_MSG_SAY")
  f:RegisterEvent("CHAT_MSG_YELL")
  f:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded

  
  
  f:SetScript("OnEvent", RaidRoll_Event)
  
  end

-- Set default variables
function RaidRoll_DefaultSetup()

  RR_Has_Rolled = false
  RR_Rolling_on_item = true
  
  rr_rollID = 0
  rr_CurrentRollID = 0
  rr_Roll = {}
  rr_PlayersRolled = {}
  rr_Item = {}
  rr_playername = {}
  RollerRoll = {}
  RollerName = {}
  RollerGroup = {}

  rr_Item[0] = "ID #0"
  
  RollerName[0] = {}
  
  RollerName[0][1] = ""
  
  RR_Timestamp = 0
  
  RR_Doing_a_New_Roll = false

end

-- What happens when an event occurs
function RaidRoll_Event()

--Debugging, shows when an event occured and what event it was
	--ChatFrame1:AddMessage("An event has occured")
	--ChatFrame1:AddMessage(arg1)


-- When the addon loads
	if event == "ADDON_LOADED" and arg1 == "RaidRoll" then
		
		-- Setup the tick boxes in the roll frame
		RaidRoll_CheckboxSetup()
		
	end
	
	if event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID_WARNING" or event == "CHAT_MSG_SAY" then
		
		-- Handles the chat messages (Finds item links, roll announcements)
		RaidRoll_ChatEventHandler(arg1)
		
	end


end

-- Setup the tick boxes in the roll frame
function RaidRoll_CheckboxSetup()
	if RR_Accept_All_Rolls == nil or RR_Accept_All_Rolls == false then
		RR_Accept_All_Rolls = false	--Set true if all rolls are counted (False = only 1-100 rolls are counted)
		RaidRoll_Allow_All:SetChecked(false)
	else
		RaidRoll_Allow_All:SetChecked(true)
	end

	if RR_Track_Unannounced_Rolls == nil or RR_Track_Unannounced_Rolls == false then
		RR_Track_Unannounced_Rolls = false	--Set true if unannounced rolls are tracked
		RaidRoll_Catch_All:SetChecked(false)
	else
		RaidRoll_Catch_All:SetChecked(true)
	end

	RR_Next:Disable()
	RR_Last:Disable()
end

-- Handles the chat messages (Finds item links, roll announcements)
function RaidRoll_ChatEventHandler(arg1)
-- Debugging, shows what messages are said
	--ChatFrame1:AddMessage(arg1)	
	

-- Get a lower case version of the string (this way "Roll" and "roll" are treated the same)
	arg1_s = string.lower(arg1)
	
--Find the start and end location of the item link
	xRR_Start_Loc,_ = string.find(arg1_s, "item:");
	_,xRR_End_Loc = string.find(arg1_s, "|h|r")
	
-- If there is no item link set the start location and end location to zero
	if xRR_Start_Loc == nil then xRR_Start_Loc = 0 end
	if xRR_End_Loc == nil then xRR_End_Loc = 0 end
	
--Get the words before and after the item link (used later to find if a roll was expected)
	RR_String_minus_ILink1 = strsub(arg1,0,xRR_Start_Loc-12)
	RR_String_minus_ILink2 = strsub(arg1,xRR_End_Loc,strlen(arg1))
	
--If they are nil set them to blank values
	if RR_String_minus_ILink1 == nil then RR_String_minus_ILink1 = "" end
	if RR_String_minus_ILink2 == nil then RR_String_minus_ILink2 = "" end
	
--Put them together
	RR_String_minus_ILink = RR_String_minus_ILink1 .. RR_String_minus_ILink2
	
--Debugging, Shows the item string without the item link
	--ChatFrame1:AddMessage(RR_String_minus_ILink)	
	
	
-- if an item link is found and it is asked to be rolled on and it is not a raid roll
	if string.find(arg1_s, "|h|r") ~= nil and string.find(RR_String_minus_ILink, "roll") ~= nil and string.find(RR_String_minus_ILink, "raid roll") == nil then 
	--Debugging, tells that a roll was detected
		--ChatFrame1:AddMessage("Rolling on an item detected")
		
	--Timestamp of when the rolling was announced
		RR_Timestamp = time()
		
	--Debugging, displays the timestamp
		--ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp)	
		
	-- This being false tells us that we should begin decrementing the counter (Otherwise it hangs at 60)
		RR_Doing_a_New_Roll = false
		
	--Cut the itemlink out of the string
		if xRR_Start_Loc ~= nil and xRR_End_Loc ~= nil then
			xRR_ItemLink = strsub(arg1,xRR_Start_Loc-12,xRR_End_Loc)
		end
		
	--For debugging, show the itemlink
		--ChatFrame1:AddMessage(xRR_ItemLink)
		
	-- If the name was previously an itemlink or the first name is blank
		if rr_Item[rr_rollID] ~= "ID #"..rr_rollID or RollerName[rr_rollID][1] ~= "" then
		-- Increment the ID
			rr_rollID = rr_rollID + 1	
			
		-- If you were at the highest ID then look at the new highest ID (otherwise, stay at the id you are at)
			if rr_CurrentRollID+1 == rr_rollID then
				rr_CurrentRollID = rr_rollID
			end
		end
		
		-- Set the name to be the itemlink
			rr_Item[rr_rollID] = xRR_ItemLink
		
		-- rr_RollSort(PlayerRoll, PlayerName, rr_rollID)
			rr_RollSort(0,"",rr_rollID)
		
		--ChatFrame1:AddMessage("New item roll found, ID#" .. rr_rollID)
	end

	RR_Rolling_on_item = true

end

